# $Id: extconf.rb,v 1.1 2000/11/28 04:50:39 keiko Exp $
# $Id: extconf.rb,v 1.2 2001/08/27 16:32:39 kawanabe Exp $

require "mkmf"

dir_config('narray',$sitearchdir,$sitearchdir)
if ( ! ( have_header("narray.h") && have_header("narray_config.h") ) ) then
print <<EOS
** configure error **  
   Header narray.h or narray_config.h is not found. If you have these files in 
   /narraydir/include, try the following:

   % ruby extconf.rb --with-narray-include=/narraydir/include

EOS
   exit(-1)
end

if(xsystem("which cdclconfig"))
  cflags = `cdclconfig --cflags`.gsub("\n", " ")
  ldflags = `cdclconfig --ldflags`.gsub("\n", " ")
  ldlibs = `cdclconfig --ldlibs`.gsub(/-R.*?\s/, " ").gsub("\n", " ")
 
  $CFLAGS += cflags  
  $LOCAL_LIBS += ldflags
  $LOCAL_LIBS += ldlibs
else
  print "**Warning** cdclconfig is not found. Assume C version of DCL 5.2\n"
  dcllibname = "cdcl52"
  f2clibname = "f2c4dcl"
  xlibname = "X11"
  dcllibdir = "-L/usr/local/lib"
  f2clibdir = "-L/usr/local/lib"
  xlibdir = "-L/usr/local/X11R6/lib"
  f2cincdir = "-I/usr/local/include"
  $CFLAGS += f2cincdir
  if(dcllibdir != f2clibdir)
    libdir = " "+dcllibdir
  else
    libdir = " "+dcllibdir+" "+f2clibdir
  end
  $LOCAL_LIBS += " "+libdir+" "+xlibdir
  $LOCAL_LIBS += " -l"+dcllibname+" -l"+f2clibname+" -l"+xlibname+" -lsocket -lnsl"
end


if(xsystem("which gtk-config"))
  gtkcflags = `gtk-config --cflags`.gsub("\n"," ")
  gtklibs = `gtk-config --libs`.gsub("\n"," ")

  fname = `pwd`.gsub("\n","/")+"testconf.c"
  file = File.open(fname,mode="w")
  file.puts <<EOF
#include <gtk/gtk.h>
int main()
{
  extern zgsdrw_(GtkWidget*);
  GtkWidget *d;
  d = gtk_drawing_area_new();
  zgsdrw_(d);
  return 0;
}
EOF
  file.close

  gtkflags = `gtk-config  --cflags`.gsub("\n"," ")
  gtkflags += `gtk-config --libs`.gsub("\n"," ")
  command = "gcc -o testconf "+fname+" "+gtkflags+"-L/usr/lib -lcdcl52 > /dev/null 2>&1"
  if(system(command))
    File.rename("grph1_zgpack.c.org","grph1_zgpack.c")
    File.rename("init.c","init.c.org")
    File.rename("init.c.gtk","init.c")
    File.delete("testconf")
    $CFLAGS += gtkcflags
    $LOCAL_LIBS += gtklibs
  else
    if(xsystem("which imlib-config"))
      imlibflags = `imlib-config --libs-gdk`.gsub("\n"," ")
      command = "gcc -o testconf "+fname+" "+imlibflags+gtkflags+"-L/usr/lib -lcdcl52 > /dev/null 2>&1"
      if(system(command))
	File.rename("grph1_zgpack.c.org","grph1_zgpack.c")
	File.rename("init.c","init.c.org")
	File.rename("init.c.gtk","init.c")
	File.delete("testconf")
	$CFLAGS += imlibflags+gtkcflags
	$LOCAL_LIBS += imlibflags+gtklibs
      end
    end
  end

  File.delete(fname)

end


create_makefile("numru/dcl_raw")

######  Modify Makefile: #######
File.rename("Makefile","Makefile.orig")
oldmkfl = File.open("Makefile.orig")
newmkfl = File.open("Makefile","w")
oldmkfl.each_line{ |line|
   case(line)
   when /^install:/
      newmkfl.puts("install: site-install")    # always site-install
   when /^distclean:/
      newmkfl.puts(line)
      newmkfl.puts("\t\t@$(RM) Makefile.orig")
   else
      newmkfl.puts(line)
   end
}
newmkfl.close
